# Gamerules
gamerule doImmediateRespawn false
gamerule spectatorsGenerateChunks true

# Destroy disabled Soul Charms
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:totem_of_undying"}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:redstone_block",count:4}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:bone_block",count:2}}
execute if score mnc_settings mnc_revival matches 0 at @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}] run summon item ~ ~ ~ {Item:{id:"minecraft:copper_block",count:2}}
execute if score mnc_settings mnc_revival matches 0 run kill @e[nbt={Item:{components:{"minecraft:custom_data":{Revive:1}}},PickupDelay:0s}]

# Revive
execute if score mnc_settings mnc_revival matches 1 run scoreboard players add mnc_settings reviveTimer 1
execute if score mnc_settings mnc_revival matches 1 if score mnc_settings reviveTimer matches 12.. run function minicore:revive

# Detect deaths
execute as @a[scores={deaths=1..}] run function minicore:death
execute as @a[scores={Lives=1..,respawn=1},gamemode=spectator] run function minicore:respawn

# Check for Life Jam uses
execute as @a[scores={lifeReset=1..}] if score mnc_settings mnc_defaultLives matches 3 run function minicore:life_reset_3
execute as @a[scores={lifeReset=1..}] if score mnc_settings mnc_defaultLives matches 5 run function minicore:life_reset_5

# Ghost particles
execute at @a[gamemode=spectator,scores={Lives=..0}] run particle dust{color:[1.000,1.000,1.000],scale:1} ~ ~1.5 ~ 0.5 0.5 0.5 0 2 force

# Possess
execute at @a[gamemode=spectator,scores={Lives=..0}] run tag @a[distance=..1,gamemode=survival] add Possessed
effect give @a[tag=Possessed] minecraft:strength 1 0 true
effect give @a[tag=Possessed] minecraft:speed 1 0 true
effect give @a[tag=Possessed] minecraft:resistance 1 0 true
effect give @a[tag=Possessed] minecraft:glowing 1 0 true
tag @a remove Possessed

# Fix scores
execute if score mnc_settings mnc_defaultLives matches 1 run scoreboard players set @a[tag=!nHrCheck] Lives 1
execute if score mnc_settings mnc_defaultLives matches 3 run scoreboard players set @a[tag=!nHrCheck] Lives 3
execute if score mnc_settings mnc_defaultLives matches 5 run scoreboard players set @a[tag=!nHrCheck] Lives 5

# Set team colors
execute if score mnc_settings mnc_nameColors matches 1 if score mnc_settings mnc_defaultLives matches 3 run function minicore:team_colors_3
execute if score mnc_settings mnc_nameColors matches 1 if score mnc_settings mnc_defaultLives matches 5 run function minicore:team_colors_5

# Set player teams
execute unless score mnc_settings mnc_defaultLives matches 1 run function minicore:join_teams

# Set lives for new players
tag @a add nHrCheck

# Fix players migrating from old packs
execute as @a[tag=nHrCheck] run execute unless score @s Lives matches 0.. run execute unless score mnc_settings mnc_migrated matches 1 run function minicore:migrate/hcrplus
execute as @a[tag=nHrCheck] run execute unless score @s Lives matches 0.. run scoreboard players set @s Lives 1
execute as @a[tag=nHrCheck, scores={Lives=4}] unless score mnc_settings mnc_defaultLives matches 5 run scoreboard players set @s Lives 3
execute as @a[tag=!mncHealthFix, scores={Lives=4}] run execute unless score mnc_settings mnc_defaultLives matches 3 run attribute @s generic.max_health base set 20
execute as @a[tag=!mncHealthFix, scores={Lives=4}] run execute unless score mnc_settings mnc_defaultLives matches 3 run tag @s add mncHealthFix
execute as @a[tag=!mncHealthFix, scores={Lives=1}] run attribute @s generic.max_health base set 20
execute as @a[tag=!mncHealthFix, scores={Lives=1}] run tag @s add mncHealthFix

# Defaults
execute unless score mnc_settings mncDefaults matches 1 run function minicore:defaults
execute unless score mnc_settings mncDefaults matches 1 run scoreboard players set mnc_settings reviveTimer 0
scoreboard players set mnc_settings mncDefaults 1
